"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useListen = useListen;
exports.useFetchDocuments = useFetchDocuments;

var _react = require("react");

var _client = _interopRequireDefault(require("part:@sanity/base/client"));

function useListen(query, params, options, onUpdate, dependencies) {
  (0, _react.useEffect)(function () {
    var subscription = _client["default"].listen(query, params, options).subscribe(function (update) {
      onUpdate(update);
    });

    return function () {
      subscription.unsubscribe();
    };
  }, dependencies);
}

function useFetchDocuments(query, onFetch, dependencies) {
  (0, _react.useEffect)(function () {
    _client["default"].fetch(query).then(function (result) {
      onFetch(result);
    });
  }, dependencies);
}